# Interface WriteListener

All Superinterfaces:
  `EventListener`

public interface WriteListener extends EventListener
Receives notification of write events when using non-blocking IO.

Since:
  Servlet 3.1

## Method Summary

Modifier and Type
Method
Description
`void`
`onError(Throwable throwable)`
Invoked if an error occurs while writing the response.
`void`
`onWritePossible()`
Invoked when it is possible to write data without blocking.

## Method Details

### onWritePossible

void onWritePossible() throws IOException
Invoked when it is possible to write data without blocking. The container will invoke this method the first time for a request as soon as data can be written. Subsequent invocations will only occur if a call to `ServletOutputStream.isReady()` has returned false, and it has since become possible to write data.

Throws:
  `IOException` - if an I/O error occurs while processing this event

### onError

void onError(Throwable throwable)
Invoked if an error occurs while writing the response.

Parameters:
  `throwable` - The throwable that represents the error that occurred